SystemOrganization addCategory: #'Croquet-Copier'!

!UndefinedObject class methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:26'!
decodeFromIslandCopierStream: byteStream
	^nil! !

!UndefinedObject methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:59'!
exportLiteralOnIslandCopier: byteStream
	"Do nothing. nil is unique"! !

!UndefinedObject methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:40'!
exportOnIslandCopier: copier
	^copier exportLiteral: self! !

!ArrayedCollection methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:14'!
objectToExportOnIslandCopier
	"Don't copy collections by default"
    ^self! !

!ArrayedCollection methodsFor: '*Croquet-Copier' stamp: 'ar 1/31/2006 19:02'!
swapEndianness
	(self class isBytes or:[self class isPointers])
		ifFalse:[Bitmap swapBytesIn: self from: 1 to: self basicSize]! !

!ChangeSet methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!Object methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:39'!
exportOnIslandCopier: copier
	^copier exportObject: self! !

!Object methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:56'!
exportReferenceOnIslandCopier: byteStream classMap: classMap
	byteStream nextNumber: 4 put: 0.
	byteStream nextNumber: 4 put: (classMap at: self class).
	self exportLiteralOnIslandCopier: byteStream.! !

!Object methodsFor: '*Croquet-Copier' stamp: 'sn 2/23/2018 11:04'!
objectToExportOnIslandCopier
    "Return an object to store on an external data stream."
    ^ self shallowCopy! !

!Object methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:06'!
postImportFromIslandCopier: importer! !

!Object methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:10'!
prepareToExportOnIslandCopier: exporter! !

Object subclass: #TIslandCopier
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Copier'!

!TIslandCopier commentStamp: '<historical>' prior: 0!
I am a facade for copying operations!

!TIslandCopier class methodsFor: 'copying' stamp: 'ar 1/14/2006 23:34'!
copy: anObject to: dstIsland
	^self new copy: anObject to: dstIsland! !

!TIslandCopier class methodsFor: 'copying' stamp: 'mtf 2/24/2010 21:49'!
version
	^SmalltalkImage current isBigEndian ifTrue:['TCPY'] ifFalse:['YPCT'].! !

!TIslandCopier methodsFor: 'copying' stamp: 'ar 1/15/2006 00:34'!
copy: anObject to: dstIsland
	| data |
	data := self export: anObject.
	^self import: data to: dstIsland.! !

!TIslandCopier methodsFor: 'copying' stamp: 'ar 1/15/2006 00:33'!
export: anObject
	| exporter |
	exporter := TIslandCopyExporter new.
	exporter export: anObject.
	^exporter contents.! !

!TIslandCopier methodsFor: 'copying' stamp: 'ar 1/15/2006 00:34'!
import: data to: dstIsland
	| importer |
	importer := dstIsland future new: TIslandCopyImporter.
	^importer future importData: data.
! !

Object subclass: #TIslandCopyData
	instanceVariableNames: 'id refClass instShape indexedSize binary data'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Copier'!

!TIslandCopyData commentStamp: '<historical>' prior: 0!
Represents a blueprint version of data for efficient storage and reconstruction.!

!TIslandCopyData class methodsFor: 'instance creation' stamp: 'ar 1/14/2006 23:52'!
new
	^self new: 0! !

!TIslandCopyData class methodsFor: 'instance creation' stamp: 'ar 1/14/2006 23:52'!
new: n
	^self basicNew initialize: n! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:21'!
at: index
	^data at: index! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:21'!
at: index put: value
	^data at: index put: value! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:21'!
binary
	^binary! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:21'!
binary: anObject
	binary := anObject.! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
binarySize
	^4 "id" + 4 "class-id" + 4 "indexed-size" +
		(binary ifNil:[self size*4] ifNotNil:[binary byteSize])! !

!TIslandCopyData methodsFor: 'exporting' stamp: 'ar 1/14/2006 23:56'!
exportDataOn: byteStream classMap: classMap swapEnds: aBool
	byteStream nextUInt32Put: (classMap at: refClass).
	"Note: instShape/instSize is implicit in class map"
	byteStream nextUInt32Put: indexedSize.
	binary ifNotNil:[
		aBool ifTrue:[binary swapEndianness].
		binary class isBytes
			ifTrue:[byteStream nextPutAll: binary asByteArray]
			ifFalse:[byteStream storeWordsFrom: binary].
		aBool ifTrue:[binary swapEndianness].
		^self].
	1 to: data size do:[:i|
		(data at: i) exportReferenceOnIslandCopier: byteStream classMap: classMap.
	].! !

!TIslandCopyData methodsFor: 'exporting' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!TIslandCopyData methodsFor: 'exporting' stamp: 'ar 1/14/2006 23:56'!
exportReferenceOnIslandCopier: byteStream classMap: classMap
	byteStream nextUInt32Put: id.! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
id
	^id! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
id: anObject
	id := anObject! !

!TIslandCopyData methodsFor: 'exporting' stamp: 'ar 1/14/2006 23:24'!
importDataFrom: byteStream classMap: classMap shapeMap: shapeMap refMap: refMap swapEnds: swapEnds
	| classID obj refID |
	classID := byteStream nextUInt32.
	refClass := classMap at: classID.

	instShape := shapeMap at: classID.
	indexedSize := byteStream nextUInt32.
	refClass isPointers ifFalse:[
		"binary blurb of data"
		binary := refClass basicNew: indexedSize.
		refClass isBytes 
			ifTrue:[byteStream nextBytesInto: binary]
			ifFalse:[byteStream readWordsInto: binary].
		swapEnds ifTrue:[binary swapEndianness].
		^self].
	"non-binary data (pointers)"
	data := Array new: (instShape size + indexedSize).
	1 to: data size do:[:i|
		refID := byteStream nextUInt32.
		refID = 0 ifTrue:[
			classID := byteStream nextUInt32.
			obj := (classMap at: classID) decodeFromIslandCopierStream: byteStream.
		] ifFalse:[
			obj := refMap at: refID.
		].
		data at: i put: obj.
	].! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
indexedSize
	^indexedSize! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
indexedSize: aNumber
	indexedSize := aNumber.! !

!TIslandCopyData methodsFor: 'initialize' stamp: 'ar 1/14/2006 23:27'!
initialize: n
	n = 0 ifTrue:[data := #()] ifFalse:[data := Array new: n].! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
instShape
	^instShape! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
instShape: aNumber
	instShape := aNumber.! !

!TIslandCopyData methodsFor: 'printing' stamp: 'ar 1/14/2006 23:27'!
printOn: aStream
	super printOn: aStream.
	aStream nextPut:$(;
		nextPutAll: refClass name;
		nextPut: $).! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
refClass
	^refClass! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
refClass: aClass
	refClass := aClass.! !

!TIslandCopyData methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:22'!
size
	^data size! !

!TIslandCopyData methodsFor: 'printing' stamp: 'ar 1/14/2006 23:27'!
storeBinaryXMLOn: writer
	| str |
false ifTrue:[
	binary class isWords ifTrue:[
		str := self wordStringOf: binary.
	] ifFalse:[
		str := String new: binary basicSize.
		str replaceFrom: 1 to: str size with: binary startingAt: 1.
	].
	str := (Base64MimeConverter mimeEncode: (ReadStream on: str)) contents.
	writer attribute: 'encoding' value:'base64'.
	writer attribute: 'order' value: Smalltalk endianness.
	writer attribute: 'data' value: str.
].
	writer endEmptyTag: refClass name.! !

!TIslandCopyData methodsFor: 'printing' stamp: 'ar 1/14/2006 23:30'!
storeXMLOn: writer
	| obj instSize |
	writer startTag: refClass name.
	writer attribute:'id' value: id abs asString.
	id < 0 ifTrue:[^writer endEmptyTag: refClass name].
	id := id negated.
	binary ifNotNil:[^self storeBinaryXMLOn: writer].
	writer endTag.
	instSize := instShape size.
	instShape keysAndValuesDo:[:i :attr|
		(obj := self at: i) ifNil:[
			writer startTag: attr; endEmptyTag: attr.
		] ifNotNil:[
			obj class == TIslandCopyData ifTrue:[
				writer startTag: attr; endTag.
				obj storeXMLOn: writer.
				writer endTag: attr.
			] ifFalse:[
				writer startTag: attr.
				writer attribute: 'value' value: obj asString.
				writer endEmptyTag: attr.
			].
		].
	].
	(indexedSize > 0) ifTrue:[
		writer startTag:'indexed-values'; endTag.
		1 to: indexedSize do:[:i|
			(obj := self at: instSize+i) ifNotNil:[
				obj class == TIslandCopyData ifTrue:[
					obj storeXMLOn: writer.
				] ifFalse:[
					writer startTag: obj class name.
					writer attribute: 'value' value: obj asString.
					writer endEmptyTag: obj class name.
				].
			].
		].
		writer endTag:'indexed-values'.
	].
	writer endTag: refClass name.! !

!TIslandCopyData methodsFor: 'printing' stamp: 'ar 1/14/2006 23:28'!
wordBitsOf: string as: wordClass
	| str src dst bits |
	str := Base64MimeConverter mimeDecode: string as: String.
	bits := wordClass new: (str size // 4).
	src := Form new hackBits: str.
	dst := Form new hackBits: bits.
	src displayOn: dst.
	^bits! !

!TIslandCopyData methodsFor: 'printing' stamp: 'ar 1/14/2006 23:28'!
wordStringOf: bits
	| str src dst |
	str := String new: bits basicSize * 4.
	src := Form new hackBits: bits.
	dst := Form new hackBits: str.
	src displayOn: dst.
	^str! !

Object subclass: #TIslandCopyExporter
	instanceVariableNames: 'lvl shapeMap byteSize refMap dataStream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Copier'!

!TIslandCopyExporter commentStamp: '<historical>' prior: 0!
The exporter is responsible for create a binary blueprint of the object to copy.!

!TIslandCopyExporter class methodsFor: 'instance creation' stamp: 'das 12/27/2005 16:43'!
copy: anObject to: anIsland
	"Create a copy of onObject in anIsland"
	^self new copy: anObject to: anIsland! !

!TIslandCopyExporter methodsFor: 'accessing' stamp: 'ar 1/15/2006 00:20'!
contents
	"Answer the binary contents of the exporter"
	^ByteArray streamContents:[:s| self writeDataOn: s].! !

!TIslandCopyExporter methodsFor: 'accessing' stamp: 'ar 1/15/2006 00:21'!
export: anObject
	^anObject exportOnIslandCopier: self! !

!TIslandCopyExporter methodsFor: 'exporting' stamp: 'ar 1/14/2006 23:37'!
exportFarRef: aFarRef
	^self error: 'Cannot export far refs'! !

!TIslandCopyExporter methodsFor: 'exporting' stamp: 'ar 1/14/2006 23:36'!
exportLiteral: value
	^value! !

!TIslandCopyExporter methodsFor: 'exporting' stamp: 'ar 1/15/2006 00:13'!
exportObject: anObject
	"Export some generic object"
	| saved instSize indexedSize data instShape |
	saved := anObject objectToExportOnIslandCopier prepareToExportOnIslandCopier: self.
	lvl := lvl + 1.
	instShape := shapeMap at: saved class ifAbsentPut:[saved class allInstVarNames asArray].
	instSize := instShape size.
	indexedSize := saved basicSize.

	saved class isPointers ifTrue:[
		data := TIslandCopyData new: (instSize + indexedSize).
		byteSize := byteSize + (4+data basicSize * 4).
		data refClass: saved class.
		data instShape: instShape.
		data indexedSize: indexedSize.
		refMap at: anObject put: data.
		1 to: instSize do:[:i| data at: i put: (self remap: (saved instVarAt: i))].
		1 to: indexedSize do:[:i| data at: instSize+i put: (self remap: (saved basicAt: i))].
	] ifFalse:[
		data := TIslandCopyData new.
		byteSize := byteSize + (4 * 4).
		data refClass: saved class.
		data instShape: instShape.
		data indexedSize: indexedSize.
		data binary: saved.
		saved class isBytes 
			ifTrue:[byteSize := byteSize + saved basicSize]
			ifFalse:[byteSize := byteSize + (saved basicSize * 4)].
		refMap at: anObject put: data.
	].
	dataStream nextPut: data.
	data id: dataStream position.
	lvl := lvl - 1.
	^data! !

!TIslandCopyExporter methodsFor: 'exporting' stamp: 'ar 1/15/2006 00:29'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!TIslandCopyExporter methodsFor: 'exporting' stamp: 'bgf 7/3/2006 02:07'!
exportProhibited: anObject
	^self error: anObject class name, ' cannot be exported'.! !

!TIslandCopyExporter methodsFor: 'exporting' stamp: 'ar 1/14/2006 23:37'!
exportTFarRef: aFarRef
	^self error: 'Cannot export far refs'! !

!TIslandCopyExporter methodsFor: 'initialize' stamp: 'ar 1/14/2006 23:41'!
initialize
	refMap := IdentityDictionary new: 10000.
	shapeMap := IdentityDictionary new: 500.
	dataStream := ReadWriteStream on: (Array new: 1000).
	lvl := -1.
	byteSize := 0.! !

!TIslandCopyExporter methodsFor: 'exporting' stamp: 'sn 2/26/2018 02:20'!
literalClasses
	^{UndefinedObject. True. False. Character. Float. BoxedFloat64. SmallInteger. 
		Symbol. ByteSymbol. WideSymbol}! !

!TIslandCopyExporter methodsFor: 'private' stamp: 'ar 1/14/2006 23:47'!
remap: anObject
	"Remap the given object to an export data reference"
	^refMap at: anObject ifAbsentPut:[anObject exportOnIslandCopier: self].! !

!TIslandCopyExporter methodsFor: 'accessing' stamp: 'ar 1/15/2006 00:21'!
writeDataOn: file
	| stream classMap shapeString count |
	file binary.
	file nextPutAll: TIslandCopier version asByteArray.
	stream := GZipWriteStream on: file.

	"Write class names and shapes"
	classMap := IdentityDictionary new.
	self literalClasses do:[:cls| shapeMap at: cls put: #()].
	stream nextUInt32Put: shapeMap size.
	shapeMap keysAndValuesDo:[:cls :clsShape|
		stream nextUInt32Put: cls name size.
		stream nextPutAll: cls name asByteArray.
		shapeString := String streamContents:[:s|
			clsShape do:[:iv| s nextPutAll: iv] separatedBy:[s space].
		].
		stream nextUInt32Put: shapeString size.
		stream nextPutAll: shapeString asByteArray.
		classMap at: cls put: (classMap size+1).
	].
	"Store data"
	count := dataStream position.
	stream nextUInt32Put: count.
	dataStream position: 0.
	1 to: count do:[:i|
		dataStream next exportDataOn: stream classMap: classMap swapEnds: false.
	].

	stream close.
	^file contents! !

Object subclass: #TIslandCopyImporter
	instanceVariableNames: 'refMap shapeMap reshapeMap attributes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Copier'!

!TIslandCopyImporter commentStamp: '<historical>' prior: 0!
The importer is responsible for restoring a binary blueprint created by an exporter.!

!TIslandCopyImporter methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:31'!
addAttribute: attrName value: value
	attributes at: attrName put: value.! !

!TIslandCopyImporter methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:31'!
attributeAt: key
	^attributes at: key! !

!TIslandCopyImporter methodsFor: 'accessing' stamp: 'ar 1/14/2006 23:31'!
attributeAt: key ifAbsent: aBlock
	^attributes at: key ifAbsent: aBlock! !

!TIslandCopyImporter methodsFor: 'importing' stamp: 'ar 1/15/2006 00:06'!
checkVersion: aStream
	| version |
	version := (aStream next: 4) asString.
	version = TIslandCopier version ifTrue:[^false]. "no byte reversal"
	version = TIslandCopier version reversed ifTrue:[^true]. "do byte reversal"
	^self error:'Invalid version info'! !

!TIslandCopyImporter methodsFor: 'importing' stamp: 'ar 1/15/2006 00:11'!
import: dataSet
	| indexedSize instSize inst instShape instClass remap |
	dataSet binary ifNotNil:[^dataSet binary].
	indexedSize := dataSet indexedSize.
	instShape := dataSet instShape.
	instClass := dataSet refClass.
	instSize := instShape size. 

	remap := shapeMap at: instClass ifAbsentPut:[instShape ~= instClass allInstVarNames].
	indexedSize = 0
		ifTrue:[inst := instClass basicNew]
		ifFalse:[inst := instClass basicNew: indexedSize].
	refMap at: dataSet put: inst.
	remap ifTrue:[
		self import: dataSet migratingTo: inst.
	] ifFalse:[
		1 to: instSize do:[:i|
			inst instVarAt: i put: (self remap: (dataSet at: i)).
		].
	].
	1 to: indexedSize do:[:i|
		inst basicAt: i put: (self remap: (dataSet at: instSize+i)).
	].
	^inst postImportFromIslandCopier: self! !

!TIslandCopyImporter methodsFor: 'importing' stamp: 'ar 1/14/2006 23:32'!
import: dataSet migratingTo: newInstance
	"Import the given data set migrating to a reshaped instance of the original class described in the data set"
	| map value mapped |
	map := reshapeMap at: newInstance class ifAbsentPut:[
		map := newInstance class allInstVarNames.
		dataSet instShape collect:[:iv| map indexOf: iv]].
	1 to: dataSet size do:[:i|
		value := self remap: (dataSet at: i).
		mapped := map at: i.
		mapped > 0 ifTrue:[newInstance instVarAt: mapped put: value].
	].
! !

!TIslandCopyImporter methodsFor: 'importing' stamp: 'ar 1/15/2006 00:19'!
importData: data
	^self importStream: data readStream! !

!TIslandCopyImporter methodsFor: 'importing' stamp: 'ar 1/14/2006 23:32'!
importStream: aStream
	| unzip count classes shapes sz string data swapEnds |
	swapEnds := self checkVersion: aStream.
	unzip := GZipReadStream on: aStream.
	"Read class names and shapes"
	count := unzip nextUInt32.
	classes := Array new: count.
	shapes := Array new: count.
	1 to: count do:[:i|
		sz := unzip nextUInt32.
		string := (unzip next: sz) asString asSymbol.
		classes at: i put: (Smalltalk at: string).
		sz := unzip nextUInt32.
		string := (unzip next: sz) asString.
		shapes at: i put: (Scanner new scanFieldNames: string).
	].
	"read data"
	count := unzip nextUInt32.
	data := Array new: count.
	1 to: count do:[:i| data at: i put: TIslandCopyData new].
	1 to: count do:[:i|
		(data at: i) importDataFrom: unzip classMap: classes shapeMap: shapes refMap: data swapEnds: swapEnds.
	].
	^self import: data last! !

!TIslandCopyImporter methodsFor: 'initialize' stamp: 'ar 1/15/2006 00:17'!
initialize
	refMap := IdentityDictionary new: 10000.
	shapeMap := IdentityDictionary new: 200.
	reshapeMap := IdentityDictionary new: 100.
	attributes := IdentityDictionary new.! !

!TIslandCopyImporter methodsFor: 'importing' stamp: 'ar 1/14/2006 23:32'!
remap: dataSet
	"Remap the given object to an export data reference"
	dataSet class == TIslandCopyData ifFalse:[^dataSet].
	^refMap at: dataSet ifAbsent:[self import: dataSet].! !

!SmallInteger class methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:25'!
decodeFromIslandCopierStream: byteStream
	^byteStream nextInt32! !

!SmallInteger methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:58'!
exportLiteralOnIslandCopier: byteStream
	byteStream nextInt32Put: self.! !

!SmallInteger methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:40'!
exportOnIslandCopier: copier
	^copier exportLiteral: self! !

!SoundBuffer methodsFor: '*Croquet-Copier' stamp: 'ar 1/31/2006 19:05'!
swapEndianness
	Smalltalk swapHalvesIn: self from: 1 to: self basicSize.! !

!Metaclass methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!ShortRunArray methodsFor: '*Croquet-Copier' stamp: 'ar 1/31/2006 19:04'!
swapEndianness
	Smalltalk swapHalvesIn: self from: 1 to: self basicSize! !

!DisplayScreen methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!Character methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:39'!
exportOnIslandCopier: copier
	^copier exportLiteral: self! !

!PositionableStream methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:54'!
nextBytesInto: byteObject

	| bytes |
	bytes := self next: byteObject basicSize.
	byteObject replaceFrom: 1 to: bytes size with: bytes startingAt: 1.
	^byteObject! !

!PositionableStream methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:54'!
nextUInt32
	"Read a 32-bit signed integer from the next 4 bytes"
	^(self next: 4) unsignedLongAt: 1 bigEndian: true! !

!PositionableStream methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:55'!
nextUInt32Put: int32
	"Write a signed integer to the next 4 bytes"
	^self nextPutAll: ((ByteArray new: 4) unsignedLongAt: 1 put: int32 bigEndian: true; yourself).! !

!PositionableStream methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:55'!
readWordsInto: aBitmap 
	| blt string |
	string := self next: aBitmap basicSize * 4.
	blt := (BitBlt current toForm: (Form new hackBits: aBitmap)) 
				sourceForm: (Form new hackBits: string).
	blt combinationRule: Form over.  "store"
	blt sourceX: 0; sourceY:  0; height: aBitmap basicSize; width: 4.
	blt destX: 0; destY: 0.
	blt copyBits.
	^ aBitmap
! !

!PositionableStream methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:55'!
storeWordsFrom: aCollection
	"Write the argument a word-like object in big endian format on the receiver.
	May be used to write other than plain word-like objects (such as ColorArray)."
	| bytes |
	bytes := ByteArray new: aCollection basicSize * 4.
	(Form new hackBits: aCollection) displayOn: (Form new hackBits: bytes).
	self nextPutAll: bytes.
	^aCollection! !

!Float class methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:24'!
decodeFromIslandCopierStream: byteStream
	| lit value |
	lit := byteStream next: 8.
	value := 0 asFloat.
	value basicAt: 1 put: (lit unsignedLongAt: 1 bigEndian: true).
	value basicAt: 2 put: (lit unsignedLongAt: 5 bigEndian: true).
	^value! !

!Float methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:58'!
exportLiteralOnIslandCopier: byteStream
	| lit |
	lit := ByteArray new: 8.
	lit unsignedLongAt: 1 put: (self basicAt: 1) bigEndian: true.
	lit unsignedLongAt: 5 put: (self basicAt: 2) bigEndian: true.
	byteStream nextPutAll: lit.! !

!Float methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:39'!
exportOnIslandCopier: copier
	^copier exportLiteral: self! !

!MatrixTransform2x3 methodsFor: '*Croquet-Copier' stamp: 'ar 1/31/2006 19:03'!
swapEndianness
	Bitmap swapBytesIn: self from: 1 to: self basicSize! !

!True class methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:26'!
decodeFromIslandCopierStream: byteStream
	^true! !

!SystemDictionary methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!SystemDictionary methodsFor: '*Croquet-Copier' stamp: 'ar 1/31/2006 19:04'!
swapHalvesIn: aNonPointerThing from: start to: stop
	"Perform a bigEndian/littleEndian byte reversal of my words.
	We only intend this for non-pointer arrays.  Do nothing if I contain pointers."
	| hack blt |
	"The implementation is a hack, but fast for large ranges"
	hack := Form new hackBits: aNonPointerThing.
	blt := (BitBlt toForm: hack) sourceForm: hack.
	blt combinationRule: Form reverse.  "XOR"
	blt sourceY: 0; destY: 0; height: self size; width: 1.
	blt sourceX: 0; destX: 1; copyBits.  "Exchange bytes 0 and 1"
	blt sourceX: 1; destX: 0; copyBits.
	blt sourceX: 0; destX: 1; copyBits.
	blt sourceX: 2; destX: 3; copyBits.  "Exchange bytes 2 and 3"
	blt sourceX: 3; destX: 2; copyBits.
	blt sourceX: 2; destX: 3; copyBits.
! !

!ShortIntegerArray methodsFor: '*Croquet-Copier' stamp: 'ar 1/31/2006 19:03'!
swapEndianness
	Smalltalk swapHalvesIn: self from: 1 to: self basicSize! !

!ProcessorScheduler methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!Process methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!FarRef methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:39'!
exportOnIslandCopier: copier
	^copier exportFarRef: self! !

!StrikeFont methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!StandardFileStream methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!Symbol class methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:25'!
decodeFromIslandCopierStream: byteStream
	^(byteStream next: (byteStream nextUInt32)) asString asSymbol.
! !

!Symbol methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:58'!
exportLiteralOnIslandCopier: byteStream
	byteStream nextUInt32Put: self basicSize.
	byteStream nextPutAll: self asByteArray! !

!Symbol methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:40'!
exportOnIslandCopier: copier
	^copier exportLiteral: self! !

!SystemOrganizer methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !

!TFarRef methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:40'!
exportOnIslandCopier: copier
	^copier exportTFarRef: self! !

!False class methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:24'!
decodeFromIslandCopierStream: byteStream
	^false! !

!Boolean methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:57'!
exportLiteralOnIslandCopier: byteStream
	"Do nothing. Knowing the class is enough."! !

!Boolean methodsFor: '*Croquet-Copier' stamp: 'ar 1/14/2006 23:39'!
exportOnIslandCopier: copier
	^copier exportLiteral: self! !

!Project methodsFor: '*Croquet-Copier' stamp: 'ar 1/15/2006 00:28'!
exportOnIslandCopier: copier
	^copier exportProhibited: self! !
